package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.ConexionExcepcionDAO;
import com.rjconsultores.ventaboletos.entidad.ConexionExcepcion;
import com.rjconsultores.ventaboletos.service.ConexionExcepcionService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("conexionExcepcionService")
public class ConexionExcepcionServiceImpl implements ConexionExcepcionService {

	@Autowired
	private ConexionExcepcionDAO conexionExcepcionDAO;

	@Override
	public List<ConexionExcepcion> obtenerTodos() {
		return conexionExcepcionDAO.obtenerTodos();
	}

	@Override
	public List<ConexionExcepcion> obtenerConexionExcepcionsActivo(Long conexionctrlId) {
		return conexionExcepcionDAO.obtenerConexionExcepcionsActivo(conexionctrlId);
	}

	@Override
	public ConexionExcepcion obtenerID(Long id) {
		return conexionExcepcionDAO.obtenerID(id);
	}

	@Override
	@Transactional
	public ConexionExcepcion suscribir(ConexionExcepcion entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return conexionExcepcionDAO.suscribir(entidad);
	}

	@Override
	@Transactional
	public ConexionExcepcion actualizacion(ConexionExcepcion entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return conexionExcepcionDAO.actualizacion(entidad);
	}

	@Override
	@Transactional
	public void borrar(ConexionExcepcion entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		conexionExcepcionDAO.actualizacion(entidad);

	}

}
